Subject: Re: Regression with wait_event_timeout in next-20140226

From: Peter Zijlstra <[email-masked]>
Date: Wed, 26 Feb 2014 17:50:43 +0100

On Wed, Feb 26, 2014 at 05:35:19PM +0100, Gregory CLEMENT wrote:
> Hi,
> 
> while testing next-20140226 I got an issue with the function
> wait_event_timeout. When this function timed out instead of returning
> 0, it returned the value of the timeout passed in parameter. I found
> that reverting "sched/wait: Suppress Sparse 'variable shadowing'
> warning" fixed this regression.
> 
> I got this issue in the driver drivers/i2c/busses/i2c-mv64xxx.c.

Ah indeed. We actually rely on the shadowing for ___wait_cond_timeout().

We further used the __ret variable in __wait_event_timeout()'s cmd
argument: __ret = schedule_timeout(__ret). That now explicitly uses the
wrong __ret.

Yeah, we need to pull that patch.